<?php
/*
 * Copyright (c) 2025 AltumCode (https://altumcode.com/)
 *
 * This software is licensed exclusively by AltumCode and is sold only via https://altumcode.com/.
 * Unauthorized distribution, modification, or use of this software without a valid license is not permitted and may be subject to applicable legal actions.
 *
 * 🌍 View all other existing AltumCode projects via https://altumcode.com/
 * 📧 Get in touch for support or general queries via https://altumcode.com/contact
 * 📤 Download the latest version via https://altumcode.com/downloads
 *
 * 🐦 X/Twitter: https://x.com/AltumCode
 * 📘 Facebook: https://facebook.com/altumcode
 * 📸 Instagram: https://instagram.com/altumcode
 */

namespace Altum\Models;

defined('ALTUMCODE') || die();

class ItemExtras extends Model {

    public function get_item_extras_by_store_id_and_item_id($store_id, $item_id) {

        /* Get the item extras */
        $item_extras = [];

        /* Try to check if the store posts exists via the cache */
        $cache_instance = cache()->getItem('s_item_extras?store_id=' . $store_id . '&item_id=' . $item_id);

        /* Set cache if not existing */
        if(is_null($cache_instance->get())) {

            /* Get data from the database */
            $item_extras_result = database()->query("
                SELECT 
                    *
                FROM 
                    `items_extras` 
                WHERE 
                    `item_id` = {$item_id} 
            ");
            while($row = $item_extras_result->fetch_object()) $item_extras[] = $row;

            cache()->save(
                $cache_instance->set($item_extras)->expiresAfter(CACHE_DEFAULT_SECONDS)->addTag('store_id=' . $store_id)
            );

        } else {

            /* Get cache */
            $item_extras = $cache_instance->get();

        }

        return $item_extras;

    }

    public function get_item_extras_by_store_id_and_item_extras_ids($store_id, $item_extras_ids) {

        $item_extras_ids = implode(',', $item_extras_ids);

        /* Get the item extras */
        $item_extras = [];

        /* Try to check if the store posts exists via the cache */
        $cache_instance = cache()->getItem('s_item_extras?store_id=' . $store_id . '&item_extras_ids=' . $item_extras_ids);

        /* Set cache if not existing */
        if(is_null($cache_instance->get())) {

            /* Get data from the database */
            $item_extras_result = database()->query("
                SELECT 
                    *
                FROM 
                    `items_extras` 
                WHERE 
                    `item_extra_id` IN ({$item_extras_ids})
            ");
            while($row = $item_extras_result->fetch_object()) $item_extras[] = $row;

            cache()->save(
                $cache_instance->set($item_extras)->expiresAfter(CACHE_DEFAULT_SECONDS)->addTag('store_id=' . $store_id)
            );

        } else {

            /* Get cache */
            $item_extras = $cache_instance->get();

        }

        return $item_extras;

    }

}
